-- ------------------------------------------------------------------------------ --
--                           TradeSkillMaster_Vendoring                           --
--           http://www.curse.com/addons/wow/tradeskillmaster_vendoring           --
--                                                                                --
--             A TradeSkillMaster Addon (http://tradeskillmaster.com)             --
--    All Rights Reserved* - Detailed license information included with addon.    --
-- ------------------------------------------------------------------------------ --

-- register this file with Ace Libraries
local TSM = select(2, ...)
TSM = LibStub("AceAddon-3.0"):NewAddon(TSM, "TSM_Vendoring", "AceEvent-3.0", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("TradeSkillMaster_Vendoring") -- loads the localization table

local private = {}

local savedDBDefaults = {
	global = {
		defaultMerchantTab = true,
		qsMarketValue = "dbmarket",
		qsMaxMarketValue = "100g",
		qsDisenchantValue = "Disenchant",
		qsMaxDisenchantValue = "100g",
		qsNumToSell = 12,
		qsExpired = 20,
		qsHideGrouped = false,
		optionsTreeStatus = {},
		defaultPage = 1,
		ignore = {},
	},
}

function TSM:OnEnable()
	-- load the savedDB into TSM.db
	TSM.db = LibStub:GetLibrary("AceDB-3.0"):New("TradeSkillMaster_VendoringDB", savedDBDefaults, true)
	
	for moduleName, module in pairs(TSM.modules) do
		TSM[moduleName] = module
	end
	
	-- register this module with TSM
	TSM:RegisterModule()
end

-- registers this module with TSM by first setting all fields and then calling TSMAPI:NewModule().
function TSM:RegisterModule()
	TSM.operations = {maxOperations=1, callbackOptions="Options:Load", callbackInfo="GetOperationInfo"}
	
	TSMAPI:NewModule(TSM)
end

TSM.operationDefaults = {
	qsAlwaysSell = false,
	qsDoNotSell = true,
	qsExpired = 20,
	qsMarketValue = "dbmarket",
	qsMaxMarketValue = "100g",
	qsDisenchantValue = "Disenchant",
	qsMaxDisenchantValue = "100g",
	-- keepQty = 0,
	ignorePlayer = {},
	ignoreFactionrealm = {},
	relationships = {},
}

function TSM:GetOperationInfo(operationName)
	local operation = TSM.operations[operationName]
	if not operation then return end
	if operation.target == "" then return end
	
	if true then return end
	-- TODO: This is the string that gets shown in the "Operations" tab of a group when you select a Vendoring operation for said group
end